Bug 985274 - PermGen memory leak on application deploy->undeploy
PermGen memory leak on application deploy->undeploy
Status: CLOSED NEXTRELEASE
Product: JBoss Enterprise Application Platform 6
Classification: JBoss
Component: Class Loading (Show other bugs)
6.1.0
Unspecified Unspecified
high Severity high
: ---
: ---
Assigned To: Dominik Pospisil
Jiri Sedlacek
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-07-17 04:38 EDT by Robert Balent
Modified: 2015-08-02 19:44 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-03-28 10:26:46 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Application to deploy (25.50 KB, application/zip)
2013-07-17 04:38 EDT, Robert Balent
no flags Details
jconsole screenshot (27.84 KB, image/png)
2013-07-17 04:39 EDT, Robert Balent
no flags Details

  None (edit)
Description Robert Balent 2013-07-17 04:38:59 EDT
Created attachment 774677 [details]
Application to deploy

When I deploy and undeploy application few times. Loaded classes are not garbage collected and server crashes on OutOfMemoryError: PermGen space.


Steps to Reproduce:
1. Download and start JBoss EAP 6.1 server
2. Download and build application attached to this issue - mvn clean install
3. Repeatedly copy and remove application in standalone/deployments directory (about 15 times).

You can easily monitor Perm Gen size with jconsole. I'm attaching jconsole screenshot.

I tried same scenario with Tomcat and it works properly.

Attached application is Camel application which should be certified with JBoss EAP for customer support.
Comment 1 Robert Balent 2013-07-17 04:39:47 EDT
Created attachment 774678 [details]
jconsole screenshot
Comment 2 Robert Balent 2013-07-17 04:40:27 EDT
Comment on attachment 774678 [details]
jconsole screenshot

Sharp line at the end is the crash
Comment 3 Robert Balent 2013-07-17 04:42:00 EDT
This bug troubles me when my testsuite have more application and I want to run it repeatedly.
Comment 4 David M. Lloyd 2013-07-17 09:14:01 EDT
All memory leaks are not class loading problems; I am just one person and cannot track down every leak in every component of the app server.  Have you done a heap analysis to discover which component is actually leaking?  It would be more appropriate to set the component to the one with the leak.
Comment 5 Robert Balent 2013-07-17 10:00:27 EDT
All dependencies are packed within the application war file. When profiling the server I see lot of ModuleClassLoader with the classes used by application even no application is deployed.

Can you please help me with some steps which can I use to provide you some more information?
Comment 10 Dominik Pospisil 2014-03-28 10:26:46 EDT
No longer reproducible on 6.x branch, closing.

Note You need to log in before you can comment on or make changes to this bug.